source("time.r")

dyn.load(paste("tst-dotC",.Platform$dynlib.ext,sep=""))

 
test.name <- "tst-dotC.1"

f <- test.cmp (function () 
{ v <- c(3L,4L)
  for (i in 1:1000000) R <- .C("tst_dotC1",numeric(1),v) 
  R
})

sys.time(R<-f())
print(R)

sym <- getNativeSymbolInfo("tst_dotC1")

f <- test.cmp (function () 
{ v <- c(3L,4L)
  for (i in 1:1000000) R <- .C(sym,numeric(1),v) 
  R
})

sys.time(R<-f())
print(R)

addr <- getNativeSymbolInfo("tst_dotC1")$address

f <- test.cmp (function () 
{ v <- c(3L,4L)
  for (i in 1:1000000) R <- .C(addr,numeric(1),v) 
  R
})

sys.time(R<-f())
print(R)

f <- test.cmp (function () 
{ v <- c(3L,4L)
  for (i in 1:1000000) R <- .C(addr,numeric(1),v,NAOK=TRUE) 
  R
})

sys.time(R<-f())
print(R)


test.name <- "tst-dotC.2"

addr <- getNativeSymbolInfo("tst_dotC2")$address

f <- test.cmp (function () 
{ a <- seq(0.01,1,length=100)
  for (i in 1:500000) R <- .C(addr,a,numeric(100),100L)
  R
})

sys.time(R<-f())
print(R)

f <- test.cmp (function () 
{ a <- seq(0.01,1,length=100)
  for (i in 1:500000) R <- .C(addr,a,numeric(100),100L,DUP=FALSE)
  R
})

sys.time(R<-f())
print(R)


test.name <- "tst-dotC.3"

addr <- getNativeSymbolInfo("tst_dotC3")$address

f <- test.cmp (function () 
{ a <- seq(0.01,1,length=100)
  b <- seq(1.01,2,length=100)
  for (i in 1:500000) R <- .C(addr,numeric(100),a,b,100L,DUP=FALSE)
  R
})

sys.time(R<-f())
print(R)

f <- test.cmp (function () 
{ a <- seq(0.01,1,length=100)
  b <- seq(1.01,2,length=100)
  for (i in 1:500000) R <- .C(addr,numeric(100),a,b,100L,DUP=FALSE)[[1]]
  R
})

sys.time(R<-f())
print(R)

f <- test.cmp (function () 
{ a <- seq(0.01,1,length=100)
  b <- seq(1.01,2,length=100)
  for (i in 1:500000) R <- .C(addr,abc=numeric(100),a,b,100L,DUP=FALSE)$abc
  R
})

sys.time(R<-f())
print(R)


test.name <- "tst-dotC.4"

addr <- getNativeSymbolInfo("tst_dotC4")$address

f <- test.cmp (function () 
{ for (i in 1:1000000) 
    R <- .C (addr, numeric(1),
    1,20,300,4000,50000,600000,7000000,80000000,900000000,10000000000)
  R
})

sys.time(R<-f())
print(R)

f <- test.cmp (function () 
{ for (i in 1:1000000) 
    R <- .C (addr, numeric(1),
    1,20,300,4000,50000,600000,7000000,80000000,900000000,10000000000,DUP=FALSE)
  R
})

sys.time(R<-f())
print(R)

f <- test.cmp (function () 
{ for (i in 1:1000000) 
    R <- .C (addr, r=numeric(1),
    1,20,300,4000,50000,600000,7000000,80000000,900000000,10000000000) $ r
  R
})

sys.time(R<-f())
print(R)
