source("time.r")

p <- (
if (exists("paste0"))
  test.cmp (function (n, a, b)
  { for (i in 1:n) x <- paste0(a,b)
    x
  }) 
else
  test.cmp (function (n, a, b)
  { for (i in 1:n) x <- paste(a,b,sep="")
    x
  })
)

f <- test.cmp (function (n, a, b, c)
{ for (i in 1:n) x <- paste(a,b,c)
  x
})

g <- test.cmp (function (n, a, b, c)
{ for (i in 1:n) x <- paste(a,b,c,collapse=" - ")
  x
})

test.name <- "tst-paste.paste0-two"

sys.time(r <- p(1000000,"ab","x"))
print(r)

sys.time(r <- p(1000000,"abcdefghijklmnopqrstuvwxyz","x123456789y123456789"))
print(r)
 
test.name <- "tst-paste.small-strings"

longa <- paste("a",1:10000)
shorta <- longa[1:10]

longb <- paste("b",1:10000)
shortb <- longb[1:10]

longc <- paste("c",1:10000)
shortc <- longc[1:10]

sys.time(r <- f(500,longa,longb,longc))
print(r[c(1,length(r))])

sys.time(r <- f(500,longa,shortb,longc))
print(r[c(1,length(r))])

sys.time(r <- f(200000,shorta,shortb,shortc))
print(r[c(1,length(r))])

sys.time(r <- g(500,longa,longb,longc))

sys.time(r <- g(500,longa,shortb,longc))

sys.time(r <- g(200000,shorta,shortb,shortc))
print(r)
 
test.name <- "tst-paste.large-strings"

longa <- paste(paste(rep("a",100),sep="",collapse=""),1:2000)
shorta <- longa[1:10]

longb <- paste(paste(rep("b",100),sep="",collapse=""),1:2000)
shortb <- longb[1:10]

longc <- paste(paste(rep("c",100),sep="",collapse=""),1:2000)
shortc <- longc[1:10]

sys.time(r <- f(500,longa,longb,longc))
print(r[c(1,length(r))])

sys.time(r <- f(500,longa,shortb,longc))
print(r[c(1,length(r))])

sys.time(r <- f(100000,shorta,shortb,shortc))
print(r[c(1,length(r))])

sys.time(r <- g(500,longa,longb,longc))

sys.time(r <- g(500,longa,shortb,longc))

sys.time(r <- g(100000,shorta,shortb,shortc))
print(r)
