source("time.r")
 
test.name <- "tst-seq-rep.seq"

f <- test.cmp (function (){for (i in 1:100000) r <- seq(1,10); r})
sys.time(r<-f()); print(r)
f <- test.cmp (function (){for (i in 1:100000) r <- seq(1,100); r})
sys.time(r<-f()); print(r)

f <- test.cmp (function (){for (i in 1:30000) r <- seq(1,20,by=2); r})
sys.time(r<-f()); print(r)
f <- test.cmp (function (){for (i in 1:30000) r <- seq(1,200,by=2); r})
sys.time(r<-f()); print(r)

f <- test.cmp (function (){for (i in 1:1000000) r <- seq.int(1,10); r})
sys.time(r<-f()); print(r)
f <- test.cmp (function (){for (i in 1:1000000) r <- seq.int(1,100); r})
sys.time(r<-f()); print(r)

f <- test.cmp (function (){for (i in 1:1000000) r <- seq.int(1,20,by=2); r})
sys.time(r<-f()); print(r)
f <- test.cmp (function (){for (i in 1:1000000) r <- seq.int(1,200,by=2); r})
sys.time(r<-f()); print(r)

test.name <- "tst-seq-rep.rep-times1"

f <- test.cmp (function (){for (i in 1:1000000) r <- rep(1.1,10); r})
sys.time(r<-f()); print(r)
f <- test.cmp (function (){for (i in 1:500000) r <- rep(1,100); r})
sys.time(r<-f()); print(r)
f <- test.cmp (function (){for (i in 1:500000) r <- rep(2L,1000); r})
sys.time(r<-f()); print(r[1:10])
 
f <- test.cmp (function (){for (i in 1:1000000) r <- rep.int(1.1,10); r})
sys.time(r<-f()); print(r)
f <- test.cmp (function (){for (i in 1:500000) r <- rep.int(1,100); r})
sys.time(r<-f()); print(r)
f <- test.cmp (function (){for (i in 1:500000) r <- rep.int(2L,1000); r})
sys.time(r<-f()); print(r[1:10])

test.name <- "tst-seq-rep.rep-times2"

f <- test.cmp (function (){for (i in 1:1000000) r <- rep(c(1.1,2.1),times=c(5,4)); r})
sys.time(r<-f()); print(r)
f <- test.cmp (function (){for (i in 1:500000) r <- rep(c(1,2),times=c(50,49)); r})
sys.time(r<-f()); print(r)

f <- test.cmp (function (){for (i in 1:1000000) r <- rep.int(c(1.1,2.1),c(5,4)); r})
sys.time(r<-f()); print(r)
f <- test.cmp (function (){for (i in 1:500000) r <- rep.int(c(1,2),c(50,49)); r})
sys.time(r<-f()); print(r)

test.name <- "tst-seq-rep.rep-each"

f <- test.cmp (function (){for (i in 1:1000000) r <- rep(c(1.1,2.1),each=5); r})
sys.time(r<-f()); print(r)
f <- test.cmp (function (){for (i in 1:500000) r <- rep(c(1,2),each=50); r})
sys.time(r<-f()); print(r)
f <- test.cmp (function (){for (i in 1:100000) r <- rep(c("a","b"),each=1000);r})
sys.time(r<-f()); print(r[c(1:10,1000:1010)])

# Some correctness checks.

for (src in list (c(T,F,T), c(1L,3L,5L), c(1,3,5), as.raw(c(1,3,5)), 
                  c(1,3,5)+1i, c("a","b","c"), list("a",T,8)))
{ 
  cat("\n\nTesting on",typeof(src),"\n\n")
  nsrc <- src
  names(nsrc) <- c("xx","yy","zz")

  f <- if (typeof(src) == "list") str else print

  f (rep(src,3));                f (rep(nsrc,3))
  f (rep.int(src,3));            f (rep.int(nsrc,3))
  f (rep(src,c(2,1,4)));         f (rep(nsrc,c(2,1,4)))
  f (rep.int(src,c(2,1,4)));     f (rep.int(nsrc,c(2,1,4)))
  f (rep(src,len=7));            f (rep(nsrc,len=7))
  f (rep(src,each=2));           f (rep(nsrc,each=2))
  f (rep(src,each=2,times=1:6)); f (rep(nsrc,each=2,times=1:6))
}
