source("time.r")


# Functions to access or replace the head or the tail of a vector.

hd <- function (x, n=1) x[seq_len(n)]
tl <- function (x, n=1) x[length(x)-n+seq_len(n)]

`hd<-` <- function (x, n=1, value) { x[seq_len(n)] <- value; x }
`tl<-` <- function (x, n=1, value) { x[length(x)-n+seq_len(n)] <- value; x }


test.name <- "tst-subfns.access"

rv <- seq(1,2,length=100001)

s <- 0
sys.time(for (i in 1:1000000) s <- s + hd(rv))
print(s)

s<-0
sys.time(for (i in 1:1000000) s <- s + hd(rv,5))
print(s)

s <- 0
sys.time(for (i in 1:1000000) s <- s + tl(rv))
print(s)

s<-0
sys.time(for (i in 1:1000000) s <- s + tl(rv,5))
print(s)

s<-0
sys.time(for (i in 1:1000000) s <- s + hd(tl(rv,5)))
print(s)


test.name <- "tst-subfns.replace"

rv <- seq(1,2,length=100001)
sys.time(for (i in 1:5000) hd(rv) <- 9)
print(rv[1:6])

rv <- seq(1,2,length=100001)
sys.time(for (i in 1:5000) hd(rv,5) <- 9)
print(rv[1:6])

rv <- seq(1,2,length=100001)
sys.time(for (i in 1:5000) tl(rv) <- 9)
print(rv[99996:100001])

rv <- seq(1,2,length=100001)
sys.time(for (i in 1:5000) tl(rv,5) <- 9)
print(rv[99996:100001])

rv <- seq(1,2,length=100001)
sys.time(for (i in 1:1000) hd(tl(rv,5),2) <- 9)
print(rv[99996:100001])

cnt <- 0
f <- function (i) { cnt <<- cnt + i + 1i; i }
rv <- seq(1,2,length=100001)
sys.time(for (i in 1:1000) hd(tl(rv,f(5)),f(2)) <- 9)
print(rv[99996:100001])
print(cnt)
